<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>NIOServerCnxnFactory.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">NIOServerCnxnFactory.java</span></div><h1>NIOServerCnxnFactory.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server;

import java.io.IOException;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.nio.ByteBuffer;
import java.nio.channels.SelectionKey;
import java.nio.channels.Selector;
import java.nio.channels.ServerSocketChannel;
import java.nio.channels.SocketChannel;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class NIOServerCnxnFactory extends ServerCnxnFactory implements Runnable {
<span class="fc" id="L39">    private static final Logger LOG = LoggerFactory.getLogger(NIOServerCnxnFactory.class);</span>

    static {
        /**
         * this is to avoid the jvm bug:
         * NullPointerException in Selector.open()
         * http://bugs.sun.com/view_bug.do?bug_id=6427854
         */
        try {
<span class="fc" id="L48">            Selector.open().close();</span>
<span class="nc" id="L49">        } catch(IOException ie) {</span>
<span class="nc" id="L50">            LOG.error(&quot;Selector failed to open&quot;, ie);</span>
<span class="fc" id="L51">        }</span>
<span class="fc" id="L52">    }</span>

    ServerSocketChannel ss;

<span class="fc" id="L56">    final Selector selector = Selector.open();</span>

    /**
     * We use this buffer to do efficient socket I/O. Since there is a single
     * sender thread per NIOServerCnxn instance, we can use a member variable to
     * only allocate it once.
    */
<span class="fc" id="L63">    final ByteBuffer directBuffer = ByteBuffer.allocateDirect(64 * 1024);</span>

<span class="fc" id="L65">    final HashMap&lt;InetAddress, Set&lt;NIOServerCnxn&gt;&gt; ipMap =</span>
        new HashMap&lt;InetAddress, Set&lt;NIOServerCnxn&gt;&gt;( );

<span class="fc" id="L68">    int maxClientCnxns = 60;</span>

    /**
     * Construct a new server connection factory which will accept an unlimited number
     * of concurrent connections from each client (up to the file descriptor
     * limits of the operating system). startup(zks) must be called subsequently.
     * @throws IOException
     */
<span class="fc" id="L76">    public NIOServerCnxnFactory() throws IOException {</span>
<span class="fc" id="L77">    }</span>

    Thread thread;
    @Override
    public void configure(InetSocketAddress addr, int maxcc) throws IOException {
<span class="fc" id="L82">        configureSaslLogin();</span>

<span class="fc" id="L84">        thread = new ZooKeeperThread(this, &quot;NIOServerCxn.Factory:&quot; + addr);</span>
<span class="fc" id="L85">        thread.setDaemon(true);</span>
<span class="fc" id="L86">        maxClientCnxns = maxcc;</span>
<span class="fc" id="L87">        this.ss = ServerSocketChannel.open();</span>
<span class="fc" id="L88">        ss.socket().setReuseAddress(true);</span>
<span class="fc" id="L89">        LOG.info(&quot;binding to port &quot; + addr);</span>
<span class="fc" id="L90">        ss.socket().bind(addr);</span>
<span class="fc" id="L91">        ss.configureBlocking(false);</span>
<span class="fc" id="L92">        ss.register(selector, SelectionKey.OP_ACCEPT);</span>
<span class="fc" id="L93">    }</span>

    /** {@inheritDoc} */
    public int getMaxClientCnxnsPerHost() {
<span class="fc" id="L97">        return maxClientCnxns;</span>
    }

    /** {@inheritDoc} */
    public void setMaxClientCnxnsPerHost(int max) {
<span class="nc" id="L102">        maxClientCnxns = max;</span>
<span class="nc" id="L103">    }</span>

    @Override
    public void start() {
        // ensure thread is started once and only once
<span class="pc bpc" id="L108" title="1 of 2 branches missed.">        if (thread.getState() == Thread.State.NEW) {</span>
<span class="fc" id="L109">            thread.start();</span>
        }
<span class="fc" id="L111">    }</span>

    @Override
    public void startup(ZooKeeperServer zks) throws IOException,
            InterruptedException {
<span class="fc" id="L116">        start();</span>
<span class="fc" id="L117">        setZooKeeperServer(zks);</span>
<span class="fc" id="L118">        zks.startdata();</span>
<span class="fc" id="L119">        zks.startup();</span>
<span class="fc" id="L120">    }</span>

    @Override
    public InetSocketAddress getLocalAddress(){
<span class="fc" id="L124">        return (InetSocketAddress)ss.socket().getLocalSocketAddress();</span>
    }

    @Override
    public int getLocalPort(){
<span class="fc" id="L129">        return ss.socket().getLocalPort();</span>
    }

    private void addCnxn(NIOServerCnxn cnxn) {
<span class="fc" id="L133">        synchronized (cnxns) {</span>
<span class="fc" id="L134">            cnxns.add(cnxn);</span>
<span class="fc" id="L135">            synchronized (ipMap){</span>
<span class="fc" id="L136">                InetAddress addr = cnxn.sock.socket().getInetAddress();</span>
<span class="fc" id="L137">                Set&lt;NIOServerCnxn&gt; s = ipMap.get(addr);</span>
<span class="fc bfc" id="L138" title="All 2 branches covered.">                if (s == null) {</span>
                    // in general we will see 1 connection from each
                    // host, setting the initial cap to 2 allows us
                    // to minimize mem usage in the common case
                    // of 1 entry --  we need to set the initial cap
                    // to 2 to avoid rehash when the first entry is added
<span class="fc" id="L144">                    s = new HashSet&lt;NIOServerCnxn&gt;(2);</span>
<span class="fc" id="L145">                    s.add(cnxn);</span>
<span class="fc" id="L146">                    ipMap.put(addr,s);</span>
                } else {
<span class="fc" id="L148">                    s.add(cnxn);</span>
                }
<span class="pc" id="L150">            }</span>
<span class="pc" id="L151">        }</span>
<span class="fc" id="L152">    }</span>

    protected NIOServerCnxn createConnection(SocketChannel sock,
            SelectionKey sk) throws IOException {
<span class="fc" id="L156">        return new NIOServerCnxn(zkServer, sock, sk, this);</span>
    }

    private int getClientCnxnCount(InetAddress cl) {
        // The ipMap lock covers both the map, and its contents
        // (that is, the cnxn sets shouldn't be modified outside of
        // this lock)
<span class="fc" id="L163">        synchronized (ipMap) {</span>
<span class="fc" id="L164">            Set&lt;NIOServerCnxn&gt; s = ipMap.get(cl);</span>
<span class="fc bfc" id="L165" title="All 2 branches covered.">            if (s == null) return 0;</span>
<span class="fc" id="L166">            return s.size();</span>
<span class="nc" id="L167">        }</span>
    }

    public void run() {
<span class="fc bfc" id="L171" title="All 2 branches covered.">        while (!ss.socket().isClosed()) {</span>
            try {
<span class="fc" id="L173">                selector.select(1000);</span>
                Set&lt;SelectionKey&gt; selected;
<span class="fc" id="L175">                synchronized (this) {</span>
<span class="fc" id="L176">                    selected = selector.selectedKeys();</span>
<span class="pc" id="L177">                }</span>
<span class="fc" id="L178">                ArrayList&lt;SelectionKey&gt; selectedList = new ArrayList&lt;SelectionKey&gt;(</span>
                        selected);
<span class="fc" id="L180">                Collections.shuffle(selectedList);</span>
<span class="fc bfc" id="L181" title="All 2 branches covered.">                for (SelectionKey k : selectedList) {</span>
<span class="fc bfc" id="L182" title="All 2 branches covered.">                    if ((k.readyOps() &amp; SelectionKey.OP_ACCEPT) != 0) {</span>
<span class="fc" id="L183">                        SocketChannel sc = ((ServerSocketChannel) k</span>
<span class="fc" id="L184">                                .channel()).accept();</span>
<span class="fc" id="L185">                        InetAddress ia = sc.socket().getInetAddress();</span>
<span class="fc" id="L186">                        int cnxncount = getClientCnxnCount(ia);</span>
<span class="pc bpc" id="L187" title="1 of 4 branches missed.">                        if (maxClientCnxns &gt; 0 &amp;&amp; cnxncount &gt;= maxClientCnxns){</span>
<span class="nc" id="L188">                            LOG.warn(&quot;Too many connections from &quot; + ia</span>
                                     + &quot; - max is &quot; + maxClientCnxns );
<span class="nc" id="L190">                            sc.close();</span>
                        } else {
<span class="fc" id="L192">                            LOG.info(&quot;Accepted socket connection from &quot;</span>
<span class="fc" id="L193">                                     + sc.socket().getRemoteSocketAddress());</span>
<span class="fc" id="L194">                            sc.configureBlocking(false);</span>
<span class="fc" id="L195">                            SelectionKey sk = sc.register(selector,</span>
                                    SelectionKey.OP_READ);
<span class="fc" id="L197">                            NIOServerCnxn cnxn = createConnection(sc, sk);</span>
<span class="fc" id="L198">                            sk.attach(cnxn);</span>
<span class="fc" id="L199">                            addCnxn(cnxn);</span>
                        }
<span class="pc bpc" id="L201" title="1 of 2 branches missed.">                    } else if ((k.readyOps() &amp; (SelectionKey.OP_READ | SelectionKey.OP_WRITE)) != 0) {</span>
<span class="fc" id="L202">                        NIOServerCnxn c = (NIOServerCnxn) k.attachment();</span>
<span class="fc" id="L203">                        c.doIO(k);</span>
<span class="fc" id="L204">                    } else {</span>
<span class="nc bnc" id="L205" title="All 2 branches missed.">                        if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L206">                            LOG.debug(&quot;Unexpected ops in select &quot;</span>
<span class="nc" id="L207">                                      + k.readyOps());</span>
                        }
                    }
<span class="fc" id="L210">                }</span>
<span class="fc" id="L211">                selected.clear();</span>
<span class="fc" id="L212">            } catch (RuntimeException e) {</span>
<span class="fc" id="L213">                LOG.warn(&quot;Ignoring unexpected runtime exception&quot;, e);</span>
<span class="nc" id="L214">            } catch (Exception e) {</span>
<span class="nc" id="L215">                LOG.warn(&quot;Ignoring exception&quot;, e);</span>
<span class="pc" id="L216">            }</span>
        }
<span class="fc" id="L218">        closeAll();</span>
<span class="fc" id="L219">        LOG.info(&quot;NIOServerCnxn factory exited run method&quot;);</span>
<span class="fc" id="L220">    }</span>

    /**
     * clear all the connections in the selector
     *
     */
    @Override
    @SuppressWarnings(&quot;unchecked&quot;)
    synchronized public void closeAll() {
<span class="fc" id="L229">        selector.wakeup();</span>
        HashSet&lt;NIOServerCnxn&gt; cnxns;
<span class="fc" id="L231">        synchronized (this.cnxns) {</span>
<span class="fc" id="L232">            cnxns = (HashSet&lt;NIOServerCnxn&gt;)this.cnxns.clone();</span>
<span class="pc" id="L233">        }</span>
        // got to clear all the connections that we have in the selector
<span class="fc bfc" id="L235" title="All 2 branches covered.">        for (NIOServerCnxn cnxn: cnxns) {</span>
            try {
                // don't hold this.cnxns lock as deadlock may occur
<span class="fc" id="L238">                cnxn.close();</span>
<span class="nc" id="L239">            } catch (Exception e) {</span>
<span class="nc" id="L240">                LOG.warn(&quot;Ignoring exception closing cnxn sessionid 0x&quot;</span>
<span class="nc" id="L241">                         + Long.toHexString(cnxn.sessionId), e);</span>
<span class="fc" id="L242">            }</span>
<span class="fc" id="L243">        }</span>
<span class="fc" id="L244">    }</span>

    public void shutdown() {
        try {
<span class="fc" id="L248">            ss.close();</span>
<span class="fc" id="L249">            closeAll();</span>
<span class="fc" id="L250">            thread.interrupt();</span>
<span class="fc" id="L251">            thread.join();</span>
<span class="fc bfc" id="L252" title="All 2 branches covered.">            if (login != null) {</span>
<span class="fc" id="L253">                login.shutdown();</span>
            }
<span class="nc" id="L255">        } catch (InterruptedException e) {</span>
<span class="nc" id="L256">            LOG.warn(&quot;Ignoring interrupted exception during shutdown&quot;, e);</span>
<span class="nc" id="L257">        } catch (Exception e) {</span>
<span class="nc" id="L258">            LOG.warn(&quot;Ignoring unexpected exception during shutdown&quot;, e);</span>
<span class="pc" id="L259">        }</span>
        try {
<span class="fc" id="L261">            selector.close();</span>
<span class="nc" id="L262">        } catch (IOException e) {</span>
<span class="nc" id="L263">            LOG.warn(&quot;Selector closing&quot;, e);</span>
<span class="fc" id="L264">        }</span>
<span class="fc bfc" id="L265" title="All 2 branches covered.">        if (zkServer != null) {</span>
<span class="fc" id="L266">            zkServer.shutdown();</span>
        }
<span class="fc" id="L268">    }</span>

    @Override
    public synchronized void closeSession(long sessionId) {
<span class="fc" id="L272">        selector.wakeup();</span>
<span class="fc" id="L273">        closeSessionWithoutWakeup(sessionId);</span>
<span class="fc" id="L274">    }</span>

    @SuppressWarnings(&quot;unchecked&quot;)
    private void closeSessionWithoutWakeup(long sessionId) {
        HashSet&lt;NIOServerCnxn&gt; cnxns;
<span class="fc" id="L279">        synchronized (this.cnxns) {</span>
<span class="fc" id="L280">            cnxns = (HashSet&lt;NIOServerCnxn&gt;)this.cnxns.clone();</span>
<span class="pc" id="L281">        }</span>

<span class="fc bfc" id="L283" title="All 2 branches covered.">        for (NIOServerCnxn cnxn : cnxns) {</span>
<span class="fc bfc" id="L284" title="All 2 branches covered.">            if (cnxn.getSessionId() == sessionId) {</span>
                try {
<span class="fc" id="L286">                    cnxn.close();</span>
<span class="nc" id="L287">                } catch (Exception e) {</span>
<span class="nc" id="L288">                    LOG.warn(&quot;exception during session close&quot;, e);</span>
<span class="fc" id="L289">                }</span>
<span class="nc" id="L290">                break;</span>
            }
<span class="fc" id="L292">        }</span>
<span class="fc" id="L293">    }</span>

    @Override
    public void join() throws InterruptedException {
<span class="fc" id="L297">        thread.join();</span>
<span class="fc" id="L298">    }</span>

    @Override
    public Iterable&lt;ServerCnxn&gt; getConnections() {
<span class="fc" id="L302">        return cnxns;</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>